## debci 0.9

=== Makefile ===
all: public/doc

include links.mk

links.mk: links
	awk '{ print("LINKS +=", $$1); print($$1, ":"); print("\tmkdir -p $$(shell dirname ", $$1, ")"); print("\tln -s", $$2, $$1)}' $^ > $@

all: $(LINKS)

.PHONY: spec check test

spec:
	rspec --color

check: spec
	test/runall.sh

test: check

public/doc: README.md RUBYAPI.md HACKING.md
	$(RM) public/doc/js/jquery.js
	yardoc --markup markdown --output-dir $@ --main README.md lib - $^
	cd public/doc/js && ln -sf ../../jquery.js

public/doc: $(shell find lib -name '*.rb')

.PHONY: tags

tags:
	ctags -R --exclude=chroots --exclude='public/jquery*' --exclude=public/bootstrap .

clean:
	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS)

=== debian/changelog ===
debci (0.9) unstable; urgency=medium

  [ Antonio Terceiro ]
  * schroot/create-testbed: update existing chroots
  * debci-generate-feeds: add description to feeds
  * Incorporate results of the Google Summer of Code 2014 project by Brandon
    Fairchild, providing uncountable improvements to the web interface.
    http://lists.alioth.debian.org/pipermail/soc-coordination/2014-August/002295.html

  [ Brandon Fairchild ]
  * web UI was improved to support multiple suites and architectures, reduce
    the dependency the UI had on Javascript, and provide more information to
    package maintainers. The documentation was also worked on to provide
    information to people interested in working on debci (specifically the web
    UI)

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 23 Aug 2014 18:10:04 -0300

debci (0.8.1) unstable; urgency=medium

  * Documentation updates
  * Fix obtaining the finish date of tests. Parsing the adt-run log started
    producing bad dates when adt-run changed to displaying only the time
    without the date. debci now uses the timestamp of when adt-run finished
    instead.
  * debci-batch: store offline mark in persistent storage to avoid going back
    online after a reboot.
  * debci-test: revert to updating only package-specific data; it turns out
    that updating global data after every package is too expensive.
  * debci-batch: update global data every 1 hour or so
  * debci-generate-index: avoid crash when regenerating data for extenal
    consumption from scratch. This process is not completely idempotent yet,
    so it needs more work.

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 18 Aug 2014 08:25:23 -0300

debci (0.8) unstable; urgency=medium

  * debci-test: update global data files, not only package-specific data file,
    after each successfull test run.
  * debci-generate-index: ensure that no two instances can run at the same
    time.

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 31 Jul 2014 11:55:27 -0300

debci (0.7.3) unstable; urgency=medium

  * debci-generate-feeds:
    - always update the global feed.
    - Point main link of feed entries to the debci log instead of the package
      page.
  * debci-generate-index:
    - report duration of each test run together with the status
  * debci-test:
    - fix regression with new packages caused by not mkdir'ing the full path
      to the adt-run output directory. `fake` backend adapted to emulate the
      behaviour of adt-run so that the tests would now fail without the fix.

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 18 Jun 2014 14:29:46 +0200

debci (0.7.2) unstable; urgency=medium

  * Fix calculation of test elapsed time. We can't store the beginning
    timestamp at the adt-run output directory because that will be wiped out
    by adt-run before running the test.
  * public/index.html: fix source code URL to point to the collab-main
    repository which is the canonical one.

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 10 Jun 2014 17:30:41 -0300

debci (0.7.1) unstable; urgency=medium

  * Fix handling of blame with "unknown" as value. Will avoid crashing when
    generating indexes

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 09 Jun 2014 11:07:11 -0300

debci (0.7) unstable; urgency=medium

  [ Antonio Terceiro ]
  * debci-batch: put packages with fastest testsuites first in the queue
  * debci-generate-feeds: allow generating feeds for specific packages
  * debci-generate-index: update package feed right away when indexing
    individual packages
  * public/app.js: Adjust the "Pass percentage" Y axis labels so that chart is
    actually a percentage chart.
  * public/index.html: add link to global Atom feed in the home page.
  * debci-test, debci-generate-index: more robust way of calculating test run
    duration. Parsing the autopkgtest log is just not good enough.

  [ Martin Pitt ]
  * Fix report_status() to work for bash scripts.
  * debci-test: Add --print-output option to write output directory to stdout.
    With that the caller can easily check the result.
  * debci, tools/server.sh: Exec the target program instead of running in a
    subprocess, for efficiency and proper SIGTERM handling.
  * Drop tools/convert-data. We only needed it for version 0.6, and we're
    going to need a different conversion script after the next data/ dir
    reorganization.
  * Reorganize data directory to move the "categories" packages/,
    autopkgtest/, status/, and feeds/ to the top level; they contain
    subdirs for all releases and architectures. This makes autopkgtest/ fully
    rsyncable and also makes it easier to the web UI to browse/present data
    for multiple releases and architectures. Also split release-arch/ into
    release/arch/.
  * Add tools/convert-data-0.7: Convert data directory to changed format from
    above.
  * Fix debci-status -l if there is just one package.
  * Add tests for debci-batch, covering skipping/re-running of tests under
    appropriate conditions and showing the cause for re-run in the log.
  * Replace test/json_validity (in ruby) with test/test_json.sh (shell with
    just calling ruby for the actual JSON validation). With that we can re-use
    test_helper's test bed setup instead of having to replicate it all in
    ruby.
  * Make test/runall.sh executable for convenience, and make it only run
    test_* scripts.
  * debci-batch: remove reading configuration from /etc/default/debci
  * lib/environment.sh: read configuration from $debci_basedir/config/debci.conf
  * Add debci_mirror config variable to configure an archive mirror. Use it
    for chdist and schroot setup.
  * Drop unnecessary faketime build dependency.
  * Add LXC backend.

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 03 Jun 2014 22:36:44 -0300

debci (0.6.3) unstable; urgency=medium

  * debian-status: avoid generating invalid JSON in the presence of packages
    without status files



=== debian/control ===
Source: debci
Section: devel
Priority: optional
Maintainer: Antonio Terceiro <terceiro@debian.org>
Build-Depends:
 debhelper (>= 9.0.0),
 devscripts,
 patchutils,
 ruby,
 ruby-rspec (>= 2.14),
 shunit2,
 fonts-font-awesome (>= 4.0.3~),
 yard,
Standards-Version: 3.9.5
Homepage: http://ci.debian.net/
Vcs-Git: git://anonscm.debian.org/collab-maint/debci.git
Vcs-Browser: http://anonscm.debian.org/gitweb?p=collab-maint/debci.git;a=summary
Testsuite: autopkgtest

Package: debci
Architecture: all
Depends:
 adduser,
 autopkgtest (>= 2.12),
 debootstrap,
 fonts-font-awesome (>= 4.0.3~),
 libjs-jquery,
 libjs-jquery-flot,
 patchutils,
 ruby,
 devscripts,
 dctrl-tools,
 ${misc:Depends},
 ${shlibs:Depends}
Recommends:
 apt-cacher-ng,
 moreutils,
 schroot
Description: continuous integration system for Debian
 debci will scan the Debian archive for packages that contain DEP-8 compliant
 test suites, and run those test suites whenever a new version of the package,
 or of any package in its dependency chain (modulo the base system), is
 available.

## debci 0.10.1

=== debian/changelog ===
debci (0.10.1) unstable; urgency=medium

  * Fix documentation build

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 30 Sep 2014 17:29:48 -0300

debci (0.10) unstable; urgency=medium

  [ Martin Pitt ]
  * Fix Makefile to be idempotent, previously it failed on already existing
    symlinks.
  * Add missing dctrl-tools build dependency, Makefile is calling grep-dctrl.
  * Makefile: Don't call "checkdeps" on "make check", the test suite doesn't
    actually need autopkgtest or the libjs packages (which are for the UI
    only).
  * test/test_helper.sh: Don't hardcode "amd64", to fix test failure when
    building on other architectures.

  [ Antonio Terceiro ]
  * debci-generate-index: update packages.json atomically
  * web UI improvements:
    - remove limit of number of items to display in the search
      (Closes: #762213)
    - trigger search immediately when there is text in the search box
      (this will happen if you reload the page)
    - store search query in the URL, and honor that when opening any page that
      contains a search box

 -- Antonio Terceiro <terceiro@debian.org>  Fri, 26 Sep 2014 18:22:06 -0300

## debci 0.10.3

=== Makefile ===
all: public/doc/index.html

include links.mk

links.mk: links
	awk '{ print("LINKS +=", $$1); print($$1, ":"); print("\tmkdir -p $$(shell dirname ", $$1, ")"); print("\tln -sf", $$2, $$1)}' $^ > $@

all: $(LINKS)

.PHONY: spec check test

checkdeps:
	@if which dpkg-checkbuilddeps >/dev/null; then dpkg-checkbuilddeps -d "$$(grep-dctrl -n -s Depends . debian/control | grep -v '\$$')"; fi

spec:
	rspec --color

functional-tests:
	test/runall.sh

check: all check-ui-and-docs spec functional-tests

check-ui-and-docs: all
	test -d public/doc
	test -f public/doc/index.html
	test -L public/doc/js/jquery.js -a -f public/doc/js/jquery.js
	test -L public/jquery.js -a -f public/jquery.js

test: check

public/doc/index.html public/doc/jq/jquery.js: README.md RUBYAPI.md HACKING.md $(shell find lib -name '*.rb')
	$(RM) public/doc/js/jquery.js
	yardoc --markup markdown --output-dir public/doc --main README.md lib - $^
	ln -sf ../../jquery.js public/doc/js/jquery.js

.PHONY: tags

tags:
	ctags -R --exclude=chroots --exclude='public/jquery*' --exclude=public/bootstrap .

clean:
	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS)

=== debian/changelog ===
debci (0.10.3) unstable; urgency=medium

  [ Brandon Fairchild ]
  * handle old test run data that didn't have a run_id.

  [ Antonio Terceiro ]
  * debci-status: fix generation of packages status file which was incorrectly
    repeating the status for the very first package over and over.

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 14 Oct 2014 18:55:27 -0300

debci (0.10.2) unstable; urgency=medium

  [ Antonio Terceiro ]
  * lib/functions.sh: accept any value of Testsuite matching `autopkgtest`
    insted of only exact matches when looking for source packages with test
    suites. This will allow detecting packages with specialized values such as
    autopkgtest-pkg-ruby and autopkgtest-pkg-perl.

  [ Brandon Fairchild ]
  * Detect JSON parsing errors on history files instead of silently failing
    and leaving a blank history (Closes: #759569)
  * Avoid also listing lib* packages under l/.

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 08 Oct 2014 08:53:37 -0300

=== debian/control ===
--- 
+++ 
@@ -11,6 +11,7 @@
  shunit2,
  fonts-font-awesome (>= 4.0.3~),
  yard,
+ dctrl-tools,
 Standards-Version: 3.9.5
 Homepage: http://ci.debian.net/
 Vcs-Git: git://anonscm.debian.org/collab-maint/debci.git
@@ -35,6 +36,7 @@
 Recommends:
  apt-cacher-ng,
  moreutils,
+ ntp,
  schroot
 Description: continuous integration system for Debian
  debci will scan the Debian archive for packages that contain DEP-8 compliant

=== debian/rules ===
#!/usr/bin/make -f

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_clean:
	dh_clean --dirs-only
	$(RM) debian/debci.debhelper.log
	$(RM) debian/debci.substvars
	$(RM) debian/files

=== debian/tests/control ===
Tests: ruby-test-suite test-suite
Depends: @, shunit2, ruby-rspec (>= 2.14)
Restrictions: allow-stderr

# vim: ft=debcontrol

## debci 0.12

=== debian/changelog ===
debci (0.12) unstable; urgency=medium

  [ Brandon Fairchild ]
  * Debci::Package#failures: Determine the test status that occurred before a
    tmpfail

  [ Antonio Terceiro ]
  * web UI: read head.html and footer.html from config dir

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 17 Dec 2014 08:45:20 -0200

debci (0.11) unstable; urgency=medium

  [ Antonio Terceiro ]
  * debci-migrate: added a data migration mechanism that is also automatically
    executed during postinst.
  * Switch data storage strategy to compress all autopkgtest logs. This will
    save huge amounts of storage space.
    - tools/server.sh adjusted to make lighttpd serve *.log.gz files as
      regular text/plain files, but with the propers headers to tell browsers
      that they are compressed so they will do the right tihng.
  * debci-batch: will now stop even in the middle of a iteration when told to
    go offline.
  * backends/schroot/create-testbed, debci-setup-chdist: add buildd suites to
    sources.list so we detect newly uploaded packages faster
  * Removed embedded copy of Bootstrap, now depending on libjs-bootstrap

  [ Brandon Fairchild ]
  * Several web UI improvements
  * Documentation update on hacking the web interface

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 15 Nov 2014 14:56:14 -0200

## debci 0.13

=== Makefile ===
--- 
+++ 
@@ -25,6 +25,7 @@
 	test -f public/doc/index.html
 	test -L public/doc/js/jquery.js -a -f public/doc/js/jquery.js
 	test -L public/jquery.js -a -f public/jquery.js
+	test -L public/bootstrap
 
 test: check

=== debian/changelog ===
debci (0.13) unstable; urgency=medium

  * debci hint: generate a britney hints file

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 18 Aug 2015 16:52:06 +0200

=== debian/control ===
--- 
+++ 
@@ -12,7 +12,7 @@
  fonts-font-awesome (>= 4.0.3~),
  yard,
  dctrl-tools,
-Standards-Version: 3.9.5
+Standards-Version: 3.9.6
 Homepage: http://ci.debian.net/
 Vcs-Git: git://anonscm.debian.org/collab-maint/debci.git
 Vcs-Browser: http://anonscm.debian.org/gitweb?p=collab-maint/debci.git;a=summary
@@ -25,6 +25,7 @@
  autopkgtest (>= 2.12),
  debootstrap,
  fonts-font-awesome (>= 4.0.3~),
+ libjs-bootstrap,
  libjs-jquery,
  libjs-jquery-flot,
  patchutils,

## debci 1.0.2

=== Makefile ===
all: doc

include links.mk

links.mk: links
	awk '{ print("LINKS +=", $$1); print($$1, ":"); print("\tmkdir -p $$(shell dirname ", $$1, ")"); print("\tln -sf", $$2, $$1)}' $^ > $@

all: $(LINKS)

.PHONY: spec check test

checkdeps:
	@if which dpkg-checkbuilddeps >/dev/null && which grep-dctrl >/dev/null; then dpkg-checkbuilddeps -d "$$(grep-dctrl -n -s Depends . debian/control | grep -v '\$$')"; fi

spec:
	@./test/banner 'Ruby unit tests'
	rspec --color

functional-tests:
	@./test/banner 'Functional tests'
	test/runall.sh
	$(RM) -v test/erl_crash.dump

backends = $(shell ls -1 backends/)
test_backends = $(patsubst %, test-%, $(backends))
.PHONY: $(test_backends)

test-backends: $(test_backends)

$(test_backends): test-% : backends/%/test-package
	@./test/banner "Test backend $*"
	./bin/debci test -b $* test/fake-package/ > log/test-$*.log 2>&1 # local source package
	./bin/debci test -b $* ruby-defaults      > log/test-$*.log 2>&1 # source package from archive

deb:
	mkdir -p tmp/deb
	rm -rf tmp/deb/debci*
	DEB_BUILD_OPTIONS=nocheck gbp buildpackage --git-export-dir=tmp/deb
	cd tmp/deb && dpkg-scanpackages . > Packages
	@echo
	@echo "Debian packages available in tmp/deb/!"

ruby-console:
	irb -Ilib -rdebci

check: all check-ui-and-docs spec functional-tests

check-ui-and-docs: all
	test -d public/doc
	test -f public/doc/index.html
	test -L public/doc/js/jquery.js -a -f public/doc/js/jquery.js
	test -L public/jquery.js -a -f public/jquery.js
	test -L public/bootstrap

test: check

doc: public/doc/index.html public/doc/architecture.svg

public/doc/index.html public/doc/jq/jquery.js: README.md docs/*.md $(shell find lib -name '*.rb')
	$(RM) public/doc/js/jquery.js
	yardoc --markup markdown --output-dir public/doc --main README.md lib - $^
	ln -sf ../../jquery.js public/doc/js/jquery.js

public/doc/architecture.svg: docs/architecture.svg
	cp docs/architecture.svg public/doc/

.PHONY: tags

tags:
	ctags -R --exclude=data --exclude=chroots --exclude='public/jquery*' --exclude=public/bootstrap .

clean:
	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS)

=== debian/changelog ===
debci (1.0.2) unstable; urgency=medium

  [ Martin Pitt ]
  * Fix some excessive amd64 hardcoding in the test suite. Thanks Colin
    Watson!
  * test/test_blame.sh: Sleep for one second between process() calls, to
    ensure that timestamps in run IDs are different. (Closes: #809265)

  [ Brian Murray ]
  * Include extra information in HTML <title> tags, such as package name,
    architecture, suite, etc (Closes: #811563)

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 25 Jan 2016 18:57:03 -0200

debci (1.0.1) unstable; urgency=medium

  * debian/debci-worker.cron.daily: exit immediately if debci is no longer
    installed (Closes: #807360)
  * Drop Debconf templates
  * bin/debci-batch: make sure package status directory exists before creating
    queue marker

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 14 Dec 2015 15:17:30 -0200

debci (1.0) unstable; urgency=medium

  * This is a major overhaul of the debci infrastructure. debci now works as a
    distributed system, with one or more workers that process test runs, and
    one central node that collects tests results and generates the HTML web
    UI. The nodes communicate using an AMQP server (usually rabbitmq-server),
    and test requests can be submitted from any host that can connect to the
    AMQP server. One will usually have one specific node, perhaps the one that
    runs the result collection/web UI, running `debci batch` to schedule tests.
  * New packages:
    + debci-worker: contains the systemd service units necessary to run the
      worker daemons; must be installed on worker nodes.
    + debci-collector: contains the systemd service unit necessary to run the
      debci collector daemon: will receive test results, and generate the HTML
      web interface; must be installed on a single node in the network
  * The `debci` package contains the debci core, and is still the package that
    needs to be installed for developers trying out debci locally as
    instructed the documentation.
  * Change default backend to `lxc`

  [ Martin Pitt ]
  * Initial implementation of the master/worker setup
  * Add support for importing data from test runs executed elsewhere

  [ Antonio Terceiro ]
  * Finished implementation of the master/worker setup
  * schroot/create-testbed: find usable union-type (Closes: #799760)
  * debian/debci.postrm: remove /var/lib/debci on purge (Closes: #769766)
  * added debian/tests/integration-test: full-system smoke test

  [ Chris Lamb ]
  * Document how to get started without a virtualisation regime
    (Closes: #777531)

  [ Brandon Fairchild ]
  * Several documentation and frontend updates
    + Including displaying correct failing architectures (Closes: #797198)

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 03 Dec 2015 22:15:30 -0200

=== debian/control ===
Source: debci
Section: devel
Priority: optional
Maintainer: Antonio Terceiro <terceiro@debian.org>
Build-Depends: amqp-tools,
               dctrl-tools,
               debhelper (>= 9.0.0),
               devscripts,
               dh-systemd (>= 1.5),
               fonts-font-awesome (>= 4.0.3~),
               patchutils,
               rabbitmq-server,
               ruby,
               ruby-rspec (>= 2.14),
               shunit2,
               yard
Standards-Version: 3.9.6
Homepage: http://ci.debian.net/
Vcs-Git: git://anonscm.debian.org/collab-maint/debci.git
Vcs-Browser: http://anonscm.debian.org/gitweb?p=collab-maint/debci.git;a=summary
Testsuite: autopkgtest

Package: debci
Architecture: all
Depends: adduser,
         amqp-tools,
         bsdmainutils,
         dctrl-tools,
         debootstrap,
         devscripts,
         fonts-font-awesome (>= 4.0.3~),
         libjs-bootstrap,
         libjs-jquery,
         libjs-jquery-flot,
         patchutils,
         ruby,
         sudo,
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: apt-cacher-ng,
            moreutils,
            ntp,
Description: continuous integration system for Debian
 debci will scan the Debian archive for packages that contain DEP-8 compliant
 test suites, and run those test suites whenever a new version of the package,
 or of any package in its dependency chain (modulo the base system), is
 available.
 .
 The requests are distributed to worker machines through AMQP queues. You need
 rabbitmq-server for this; but it is also possible to run RabbitMQ on a
 different server than debci, in which case you do not need to install that
 recommendation.
 .
 This package contains the debci core.

Package: debci-worker
Architecture: all
Depends: debci (= ${binary:Version}),
         autodep8 (>= 0.2~),
         autopkgtest (>= 3.16),
         schroot | lxc,
         ${misc:Depends},
         ${shlibs:Depends}
Description: continuous integration system for Debian (worker daemon)
 debci will scan the Debian archive for packages that contain DEP-8 compliant
 test suites, and run those test suites whenever a new version of the package,
 or of any package in its dependency chain (modulo the base system), is
 available.
 .
 The requests are distributed to worker machines through AMQP queues. You need
 rabbitmq-server for this; but it is also possible to run RabbitMQ on a
 different server than debci, in which case you do not need to install that
 recommendation.
 .
 This package provides cron and init integration for running debci worker
 daemons that will listen to AMQP queues and run test jobs.

Package: debci-collector
Architecture: all
Depends: debci (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Recommends: rabbitmq-server,
Description: continuous integration system for Debian (collector daemon)
 debci will scan the Debian archive for packages that contain DEP-8 compliant
 test suites, and run those test suites whenever a new version of the package,
 or of any package in its dependency chain (modulo the base system), is
 available.
 .
 The requests are distributed to worker machines through AMQP queues. You need
 rabbitmq-server for this; but it is also possible to run RabbitMQ on a
 different server than debci, in which case you do not need to install that
 recommendation.
 .
 This package provides the collector daemon, which will receive test results
 published by debci worker hosts, store them centrally, and generate the static
 HTML files for the debci user interface.

=== debian/rules ===
--- 
+++ 
@@ -4,10 +4,13 @@
 #export DH_VERBOSE=1
 
 %:
-	dh $@
+	dh $@ --with systemd
 
 override_dh_clean:
 	dh_clean --dirs-only
 	$(RM) debian/debci.debhelper.log
 	$(RM) debian/debci.substvars
 	$(RM) debian/files
+
+override_dh_installinit:
+	@true

=== debian/tests/control ===
Tests: ruby-test-suite test-suite
Depends: debci, shunit2, ruby-rspec (>= 2.14), rabbitmq-server
Restrictions: allow-stderr needs-recommends

Tests: integration-test
Depends: debci, shunit2, rabbitmq-server
Restrictions: allow-stderr, isolation-container, needs-root

# vim: ft=debcontrol

## debci 1.3

=== debian/changelog ===
debci (1.3) unstable; urgency=medium

  * debci-collector:
    - remove creation of .timestamp files under data/autopkgtest-incoming/,
      which are no longer used for anything
  * bin/debci-batch:
    - use one tmp_dir per package/suite/architecture
  * bin/debci-generate-index
    - use one tmp_dir per package/suite/architecture
    - compress artifacts (except log) in a single tarball so that instead of N
      files per test run, we only keep 2 files per test run: log.gz and
      artifacts.tar.gz. This should significantly reduce the usage of inodes.

 -- Antonio Terceiro <terceiro@debian.org>  Fri, 03 Jun 2016 16:26:11 -0300

debci (1.2) unstable; urgency=medium

  [ Antonio Terceiro ]
  * debian/debci-worker@.service: also bump LimitNPROC to infinity to avoid
    the `Cannot fork` issue.
  * backends/lxc/test-package: use adt-virt-lxc --name option to facilitate
    mapping from a running test to package names. This requires autopkgtest
    (>= 3.20).
  * bin/debci-collector, bin/debci-worker, lib/functions.sh#report_status:
    display suite and architecture together with package names
  * HTML UI:
    * add page listing Platform-specific issues, i.e. packages that passes on
      one suite/arch but fails on another suite/arch.
    * fix Status page to not hide all charts when any platform does not have
      enough data
    * rewrite Status charts page. In special, instead of loading the full
      history via AJAX, which takes quite a while, embed a reduced view of the
      data in the HTML itself.
    * remove search functionality: it was too heavy/slow. If one day the UI
      stops being only static HTML, we can a search feature again.
  * Drop debian/tests/worker-max-processes. The original issue was caused by
    (and fixed in) systemd >= 228 (see bug #823530), and the test ended up not
    being very reliable and keeps flapping on CI.
  * bin/debci-generate-index: remove call to debci-generate-html, since
    debci-update now call both debci-generate-index and debci-generate-html

  [ Jakub Wilk ]
  * public/style.css: Set correct font for alert, chart, rss, and tracker
    icons. (Closes: #821932)

  [ Brandon Fairchild ]
  * HTML UI: fix final copyright year in the footer

 -- Antonio Terceiro <terceiro@debian.org>  Mon, 23 May 2016 10:31:19 -0300

debci (1.1.2) unstable; urgency=medium

  * debian/tests/control: restrict backend-schroot to only running on VMs
    (i.e. not on containers)
  * debian/debci-worker@.service: make sure there is no maximum number of
    processes; otherwise when using the lxc backend, we might get random
    failures saying `Cannot fork: resource temporarily unavailable` with
    systemd from stretch onwards.
    - added debian/tests/worker-max-processes as a test case
  * Add new backend `null`, which just uses the `null` virtualization regime
    in adt-run. This will be useful for running tests, but can also be used
    for running tests with zero overhead on trusted packages.
  * backends/fake: add support for executing an specific command instead of
    producing a random result if $DEBCI_FAKE_COMMAND is set.

 -- Antonio Terceiro <terceiro@debian.org>  Tue, 12 Apr 2016 11:23:17 -0300

debci (1.1.1) unstable; urgency=medium

  * debian/sudoers.d/debci: adjust to work with autopkgtest >= 3.19.3,
    which will also call `timeout` under sudo.
  * backends/lxc/create-testbed: initialize $GUEST_PROXY before use, for the
    case when no proxy is detected.
  * Add integration tests for schroot and lxc backends
  * debian/tests/integration-test: wait until test jobs have been processed,
    to avoid failures due to not waiting long enough on slow machines.
  * debian/tests/control: force throwing away used testbed after
    integration-test and multiarch-integration-test

 -- Antonio Terceiro <terceiro@debian.org>  Sun, 27 Mar 2016 22:42:29 -0300

debci (1.1.0) unstable; urgency=medium

  New features:

  * debci-config: added option to output only values and not keys
  * Proper support for multiple architectures.
    - list of architectures is declared in the configuration file using the
      `debci_arch_list` variable.
    - new script debci-update will call debci-generate-index for each of the
      architectures in $debci_arch_list, and them call debci-generate-html
      which was already architecture-independent.
    - systemd unit files debci-generate-index.{service,timer} renamed to
      debci-update.{service,timer}. debci-update.service and changed to call
      `debci update` instead of `debci generate-index`.

  Bug fixes:

  * remove unused debian/po directory (Closes: #813447)
  * test_helper: stop rabbitmq-server the right way

  Minor packaging updates:

  * remove deprecated and unused tools
  * debian/control: Use https URLs in Vcs-* fields
  * debian/control: Bump Standars-Version to 3.9.7; no changes needed

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 26 Mar 2016 18:59:52 -0300

=== debian/control ===
--- 
+++ 
@@ -8,16 +8,17 @@
                devscripts,
                dh-systemd (>= 1.5),
                fonts-font-awesome (>= 4.0.3~),
+               moreutils,
                patchutils,
                rabbitmq-server,
                ruby,
                ruby-rspec (>= 2.14),
                shunit2,
                yard
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Homepage: http://ci.debian.net/
-Vcs-Git: git://anonscm.debian.org/collab-maint/debci.git
-Vcs-Browser: http://anonscm.debian.org/gitweb?p=collab-maint/debci.git;a=summary
+Vcs-Git: https://anonscm.debian.org/git/collab-maint/debci.git
+Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/debci.git
 Testsuite: autopkgtest
 
 Package: debci
@@ -57,7 +58,7 @@
 Architecture: all
 Depends: debci (= ${binary:Version}),
          autodep8 (>= 0.2~),
-         autopkgtest (>= 3.16),
+         autopkgtest (>= 3.20),
          schroot | lxc,
          ${misc:Depends},
          ${shlibs:Depends}

## debci 1.5.1

=== Makefile ===
--- 
+++ 
@@ -14,7 +14,8 @@
 
 spec:
 	@./test/banner 'Ruby unit tests'
-	rspec --color
+	@echo rspec --color
+	@rspec --color || (if [ -n "$(DISPLAY)" ]; then notify-send --urgency=critical --expire-time=5 "FAILED!!!"; fi; false)
 
 functional-tests:
 	@./test/banner 'Functional tests'
@@ -35,7 +36,7 @@
 deb:
 	mkdir -p tmp/deb
 	rm -rf tmp/deb/debci*
-	DEB_BUILD_OPTIONS=nocheck gbp buildpackage --git-export-dir=tmp/deb
+	DEB_BUILD_OPTIONS=nocheck gbp buildpackage --git-ignore-branch --git-export-dir=tmp/deb
 	cd tmp/deb && dpkg-scanpackages . > Packages
 	@echo
 	@echo "Debian packages available in tmp/deb/!"

=== debian/changelog ===
debci (1.5.1) unstable; urgency=medium

  [ Brandon Fairchild ]
  * TUTORIAL.md: Add links to DDPO and package tracker

  [ Antonio Terceiro ]
  * docs/TUTORIAL.md: add link to DMD as well
  * debci-setup-chdist:
    - use $MIRROR as default mirror
  * debci-generate-index:
    - handle sub-directories of the artifacts/ directory produced by
      autopkgtest.

  [ Paul Gevers ]
  * Simplify the instructions to enable sudo to work on lxc-* now that debci
    ships an sudoers.d/debci file

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 26 Jan 2017 10:27:45 -0200

debci (1.5) unstable; urgency=medium

  * debci setup
    - add -f/--force option to force an update, ignoring the testbed timestamp
  * web UI
    - fix links to packages in "status alerts" page
  * packaging:
    + debci-worker: move `apt-cacher-ng` from Recommends: to Suggests:. In
      practice, workers should usually be close to a good mirror; having a
      local cache increases the maintaince burden as the disk usage might go
      too high.
  * lxc backend:
    + drop "adt-sid-amd64-" prefix from container names. In practice,
      container names longer than 64 characters cause problems.
  * setup-chdist:
    + drop usage of timestamp to control when to call `apt-get update`. Just
      update always. an `apt-get update` on a updated tree should be quick
      enough.

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 27 Oct 2016 19:38:44 -0200

debci (1.4) unstable; urgency=medium

  [ Antonio Terceiro ]
  * bin/debci-migrate.d/002_compress_artifacts: also remove directories after
    compressing artifacts
  * Web UI:
    - include version numbers almost everywhere.
  * lib/debci/html/package.erb: avoid crashing when installing a fresh system
    with no data, but with packages already blacklisted.
  * debian/debci.postrm: remove /var/log/debci on purge (Closes: #810701)
  * Add support for running tests for multiple suites (See: #831975).
    .
    Not that we couldn't do that already, but it would require specific
    workers for each suite. With these changes, a worker node for a given
    architecture can now run tests on any suite for that architecture.
    .
    - debci-worker will now expect the suite name as a second argument on test
      jobs (defaulting to whatever is in $debci_suite).
    - debci-enqueue will now send the suite name as a second argument on each
      test job
    - Added debci-update-worker as a wrapper for callling debci-setup for each
      supported suite.
  * backends/lxc:
    - retry `apt-get update` until it works. Most of the time when the testbed
      setup fails on production is during `apt-get update`.
  * "Platform-Specific issues" will now not consider tmpfail as an issue.
    Those are already being tracked by "Status alerts".
  * test/test_shell_best_practices.sh: start checking scripts with shellcheck;
    not failing on issues just yet.

  [ Gordon Ball ]
  * Add the concept of failure states, to distinguish between
    * tests which have never passed
    * tests which passed for a previous version, but never for the current
      version
    * tests which previously passed for the current version


 -- Antonio Terceiro <terceiro@debian.org>  Sun, 04 Sep 2016 18:27:51 -0300

=== debian/control ===
--- 
+++ 
@@ -8,11 +8,16 @@
                devscripts,
                dh-systemd (>= 1.5),
                fonts-font-awesome (>= 4.0.3~),
+               inotify-tools,
+               jq,
                moreutils,
                patchutils,
                rabbitmq-server,
+               rerun,
                ruby,
+               ruby-foreman,
                ruby-rspec (>= 2.14),
+               shellcheck,
                shunit2,
                yard
 Standards-Version: 3.9.8
@@ -36,11 +41,12 @@
          patchutils,
          ruby,
          sudo,
+         jq,
          ${misc:Depends},
          ${shlibs:Depends}
-Recommends: apt-cacher-ng,
-            moreutils,
+Recommends: moreutils,
             ntp,
+Suggests: apt-cacher-ng,
 Description: continuous integration system for Debian
  debci will scan the Debian archive for packages that contain DEP-8 compliant
  test suites, and run those test suites whenever a new version of the package,
@@ -59,7 +65,7 @@
 Depends: debci (= ${binary:Version}),
          autodep8 (>= 0.2~),
          autopkgtest (>= 3.20),
-         schroot | lxc,
+         lxc | schroot,
          ${misc:Depends},
          ${shlibs:Depends}
 Description: continuous integration system for Debian (worker daemon)

## debci 1.7

=== debian/changelog ===
debci (1.7) unstable; urgency=medium

  [ Martin Pitt ]
  * Move from obsolete adt-run to autopkgtest CLI (Closes: #866867)

  [ Antonio Terceiro ]
  * debian/NEWS: document changes to base testbed names due to the move to
    `autopkgtest` from `adt-run`.
  * debci-setup: don't mask failure of the backend create-testbed script
    (Closes: #809652)
  * backends/lxc: cleanup containers if testbed creation fails, making sure
    that calls to debci-setup will always exit cleanly.
  * New program: debci localtest. It can be used by users to reproduce locally
    the same test environment used in ci.debian.net.
    - autopkgtest calls make by backends/*/test-package will now use the
      --no-built-binaries option.
  * Add debci(1) manpage and support `debci --help` (Closes: #867891)
  * Add an experiental `qemu` backend

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 26 Jul 2017 17:44:47 -0300

debci (1.6) unstable; urgency=medium

  * docs/INSTALL.md: update rabbitmq-related instructions
  * Debci::HTML: record template filename
  * Debci::Graph: assume empty array when there is no data
  * debci-expire: control data retention
  * Drop unnecessary symlinks to autopkgtest logs
  * web UI: don't link to removed files
  * debian/rules: skip running tests during build (Closes: #841708, #848054)
  * debci-worker.cron.daily: skip if debci-worker is not installed
    (Closes: #822896)
  * debian/*.service: add Documentation entry, pointing to online debci docs

 -- Antonio Terceiro <terceiro@debian.org>  Sun, 28 May 2017 17:22:50 -0300

=== debian/control ===
--- 
+++ 
@@ -20,7 +20,7 @@
                shellcheck,
                shunit2,
                yard
-Standards-Version: 3.9.8
+Standards-Version: 4.0.0
 Homepage: http://ci.debian.net/
 Vcs-Git: https://anonscm.debian.org/git/collab-maint/debci.git
 Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/debci.git
@@ -64,7 +64,7 @@
 Architecture: all
 Depends: debci (= ${binary:Version}),
          autodep8 (>= 0.2~),
-         autopkgtest (>= 3.20),
+         autopkgtest (>= 4),
          lxc | schroot,
          ${misc:Depends},
          ${shlibs:Depends}

## debci 1.7.1

=== Makefile ===
--- 
+++ 
@@ -5,7 +5,9 @@
 links.mk: links
 	awk '{ print("LINKS +=", $$1); print($$1, ":"); print("\tmkdir -p $$(shell dirname ", $$1, ")"); print("\tln -sf", $$2, $$1)}' $^ > $@
 
-all: $(LINKS)
+MANPAGES = $(patsubst bin/%, man/%.1, $(shell grep -rl =head1 bin/*))
+
+all: $(LINKS) $(MANPAGES)
 
 .PHONY: spec check test
 
@@ -65,10 +67,16 @@
 public/doc/architecture.svg: docs/architecture.svg
 	cp docs/architecture.svg public/doc/
 
+$(MANPAGES): man/%.1: bin/% man
+	pod2man --center "" --release "" --section=1 --utf8 $< $@
+
+man:
+	mkdir $@
+
 .PHONY: tags
 
 tags:
 	ctags -R --exclude=data --exclude=chroots --exclude='public/jquery*' --exclude=public/bootstrap .
 
 clean:
-	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS)
+	$(RM) -rf $(generated) tags public/doc links.mk $(LINKS) man/

=== debian/changelog ===
debci (1.7.1) unstable; urgency=medium

  * debian/control:
    - debci: recommend `ntp | time-daemon` instead of just `ntp`
      (Closes: #870739)
  * debian/debci-worker.cron.daily: also bail out immediately if debci is not
    installed (Closes: 822896)

 -- Antonio Terceiro <terceiro@debian.org>  Sun, 10 Sep 2017 13:35:21 -0300

=== debian/control ===
--- 
+++ 
@@ -45,7 +45,7 @@
          ${misc:Depends},
          ${shlibs:Depends}
 Recommends: moreutils,
-            ntp,
+            ntp | time-daemon,
 Suggests: apt-cacher-ng,
 Description: continuous integration system for Debian
  debci will scan the Debian archive for packages that contain DEP-8 compliant

=== debian/rules ===
--- 
+++ 
@@ -12,5 +12,9 @@
 	$(RM) debian/debci.substvars
 	$(RM) debian/files
 
+override_dh_auto_test:
+	# skip buid-time tests for now
+	@true
+
 override_dh_installinit:
 	@true

=== debian/tests/control ===
--- 
+++ 
@@ -4,6 +4,18 @@
 
 Tests: integration-test
 Depends: debci, shunit2, rabbitmq-server
-Restrictions: allow-stderr, isolation-container, needs-root
+Restrictions: allow-stderr, isolation-container, needs-root, breaks-testbed
+
+Tests: multiarch-integration-test
+Depends: debci, shunit2, rabbitmq-server
+Restrictions: allow-stderr, isolation-container, needs-root, breaks-testbed
+
+Tests: backend-schroot
+Depends: debci, libnss-myhostname, netcat-openbsd, redir, autopkgtest, schroot
+Restrictions: allow-stderr, isolation-machine, needs-root
+
+Tests: backend-lxc
+Depends: debci, libnss-myhostname, netcat-openbsd, redir, autopkgtest, lxc, rsync, libvirt-clients, libvirt-daemon-system, iptables, ebtables, dnsmasq-base
+Restrictions: allow-stderr, isolation-machine, needs-root
 
 # vim: ft=debcontrol

=== debian/tests/testpkg/debian/tests/control ===
Test-Command: true
Depends: bash

=== test/fake-package/debian/tests/control ===
Test-Command: true
Depends: dpkg

## debci 1.12

=== Makefile ===
--- 
+++ 
@@ -16,8 +16,7 @@
 
 spec:
 	@./test/banner 'Ruby unit tests'
-	@echo rspec --color
-	@rspec --color || (if [ -n "$(DISPLAY)" ]; then notify-send --urgency=critical --expire-time=5 "FAILED!!!"; fi; false)
+	rspec --color
 
 functional-tests:
 	@./test/banner 'Functional tests'
@@ -59,7 +58,7 @@
 
 doc: public/doc/index.html public/doc/architecture.svg
 
-public/doc/index.html public/doc/jq/jquery.js: README.md docs/*.md $(shell find lib -name '*.rb')
+public/doc/index.html public/doc/jq/jquery.js: README.md $(sort $(wildcard docs/*.md)) $(shell find lib -name '*.rb' | LC_ALL=C sort)
 	$(RM) public/doc/js/jquery.js
 	yardoc --markup markdown --output-dir public/doc --main README.md lib - $^
 	ln -sf ../../jquery.js public/doc/js/jquery.js

=== debian/changelog ===
debci (1.12) unstable; urgency=medium

  [ Antonio Terceiro ]
  * ui: add status name back in package history page
  * lxc, schroot: don't make `debci` a system user
  * tools/init-dev.sh: reduce number of suites
  * tools/init-dev.sh: separate config files from test requests
  * debci-collector: replace pointless loop with conditional
  * Escape triggers when enqueuing test jobs (Closes: #902337)

  [ Paul Gevers ]
  * Treat autopkgtest exit status 8 as a neutral result (Closes: #901846)
  * debci.(pre|post)(inst|rm): call dpkg-maintscript-helper to adapt for
    change of directory to link in previous version
  * backends/debci-setup-chdist: add contrib and non-free (Closes: #825488)
  * backends: add debug archive to lxc and schroot (Closes: #817080)

 -- Paul Gevers <elbrus@debian.org>  Fri, 10 Aug 2018 20:06:49 +0200

debci (1.11) unstable; urgency=medium

  [ Antonio Terceiro ]
  * ui: pending jobs: add columns for suite and architecture
  * debci-generate-index: make sure to always run
  * Remove all handling of "blame"
  * Remove generation of britney hints file
  * Fix debci-localtest
  * Build-Depends: autopkgtest
  * debci-enqueue: log suite and architecture
  * debian/tests/control: install autopkgtest to run test suite
  * Debci::API: accept only package names starting with [a-z0-9]
  * ui: Optimize HTML generation process
  * Use FontAwesome via its standard API
  * lxc: name containers ci-$EPOCH (Closes: #893595, #898875)
  * Implement test priorities
  * ui: improve "Status Alerts" table
  * ui: add status page for slow-running tests
  * Bump Standards-Version to 4.1.4, no changes needed

  [ Paul Gevers ]
  * README.md: fix unsecure http URL's and fix e-mail list address

  [ Rafael Laboissiere ]
  * d/control: Change Maintainer to Debian CI team.
    Antonio Terceiro, the former Maintainer, is now an Uploader.

 -- Antonio Terceiro <terceiro@debian.org>  Wed, 13 Jun 2018 09:51:09 -0300

debci (1.10) unstable; urgency=medium

  * api: enable retry with client certificate and add GET response
  * Minor packaging updates
  * Thanks to Chris Lamb for the patches of bugs 880804, 879655 and
    879654.

 -- Paul Gevers <elbrus@debian.org>  Wed, 25 Apr 2018 15:10:36 +0200

debci (1.9.1) unstable; urgency=medium

  * api: accept + in package names

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 07 Apr 2018 15:45:26 -0300

debci (1.9) unstable; urgency=medium

  [ Paul Gevers ]
  * Make building debci reproducible (Closes: #880804)
  * Move from http://http.debian.net to http://deb.debian.org (Closes: #879654)
  * Document the use of a local mirror (Closes: #879655)
  * Document the need for running chdist
  * docs: fix typo

  [ Antonio Terceiro ]
  * debci-setup: mention suite in the logs
  * tools/build.sh: tell rerun that `make` exits
  * tools/init-dev.sh: initialize database
  * debci-worker: refuse invalid package names
  * api: reject invalid package names
  * Use salsa.debian.org in Vcs-* fields

 -- Antonio Terceiro <terceiro@debian.org>  Sat, 07 Apr 2018 15:24:55 -0300

debci (1.8) unstable; urgency=medium

  [ Antonio Terceiro ]
  * This release adds two major features that were developed to support
    triggering tests to speed up Debian testing migrations:
    * Added support for "migration tests", which are tests that run on testbeds
      of a given suite (e.g. testing) with some packages from another suite
      (e.g.  unstable).
    * Added an HTTP API for requesting test runs. This will be used by britney
      to test package versions from unstable against testing.
  * debci setup: pass --suite to testbed creation scripts
  * debci test: Extract autopkgtest calls into a central helper program
  * backends/lxc: drop the unstable → sid renaming
  * Add script to run a Ruby shell
  * Move enqueing process to Ruby for performance reasons
  * debian/control
    * replace build dependency on dh-systemd with debhelper (>= 9.20160709)
    * Bump Standards-Version to 4.1.3; no changes needed
    * remove unnecessary Testsuite: field

  [ Paul Gevers ]
  * backends/fake: use month instead of minutes in the generated package name
    for non-existent packages
  * backends/fake: use rmadison get more up-to-date version numbers
  * Initial version for a page where one can see which jobs have pending
    results
  * Add retrigger end point to the API

  [ Lucas Kanashiro ]
  * Update git repository URL to point to salsa
  * UI: sort package status history based on date in descending order
  * define pipeline via gitlab-ci.yml

 -- Antonio Terceiro <terceiro@debian.org>  Thu, 15 Mar 2018 14:52:34 -0300

=== debian/control ===
--- 
+++ 
@@ -1,12 +1,13 @@
 Source: debci
 Section: devel
 Priority: optional
-Maintainer: Antonio Terceiro <terceiro@debian.org>
+Maintainer: Debian CI team <team+ci@tracker.debian.org>
+Uploaders: Antonio Terceiro <terceiro@debian.org>, Paul Gevers <elbrus@debian.org>,
 Build-Depends: amqp-tools,
+               autopkgtest,
                dctrl-tools,
-               debhelper (>= 9.0.0),
+               debhelper (>= 9.20160709),
                devscripts,
-               dh-systemd (>= 1.5),
                fonts-font-awesome (>= 4.0.3~),
                inotify-tools,
                jq,
@@ -15,22 +16,28 @@
                rabbitmq-server,
                rerun,
                ruby,
+               ruby-activerecord,
+               ruby-bunny,
                ruby-foreman,
                ruby-rspec (>= 2.14),
+               ruby-sinatra,
+               ruby-sinatra-contrib,
+               ruby-sqlite3,
+               ruby-thor,
                shellcheck,
                shunit2,
                yard
-Standards-Version: 4.0.0
+Standards-Version: 4.1.4
 Homepage: http://ci.debian.net/
-Vcs-Git: https://anonscm.debian.org/git/collab-maint/debci.git
-Vcs-Browser: https://anonscm.debian.org/cgit/collab-maint/debci.git
-Testsuite: autopkgtest
+Vcs-Git: https://salsa.debian.org/ci-team/debci.git
+Vcs-Browser: https://salsa.debian.org/ci-team/debci
 
 Package: debci
 Architecture: all
 Depends: adduser,
          amqp-tools,
          bsdmainutils,
+         curl,
          dctrl-tools,
          debootstrap,
          devscripts,
@@ -40,6 +47,12 @@
          libjs-jquery-flot,
          patchutils,
          ruby,
+         ruby-activerecord,
+         ruby-bunny,
+         ruby-sinatra,
+         ruby-sinatra-contrib,
+         ruby-sqlite3 | ruby-pg,
+         ruby-thor,
          sudo,
          jq,
          ${misc:Depends},
@@ -64,7 +77,7 @@
 Architecture: all
 Depends: debci (= ${binary:Version}),
          autodep8 (>= 0.2~),
-         autopkgtest (>= 4),
+         autopkgtest (>= 5.1~),
          lxc | schroot,
          ${misc:Depends},
          ${shlibs:Depends}

=== debian/tests/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Tests: ruby-test-suite test-suite
-Depends: debci, shunit2, ruby-rspec (>= 2.14), rabbitmq-server
+Depends: debci, shunit2, ruby-rspec (>= 2.14), rabbitmq-server, autopkgtest
 Restrictions: allow-stderr needs-recommends
 
 Tests: integration-test
